class _PoolManagerWrapper:
    """
    Wrapper around urllib3.PoolManager that implements request() which
    is the only method used by the autogenerated API code

    It can be used to replace tiledb.cloud.rest_api.rest.RESTClientObject.pool_manager
    at runtime to work around https://github.com/urllib3/urllib3/issues/2475
    """

    def __init__(self, pool_manager):
        self._pool = pool_manager

    def request(self, method, url, **kwargs):
        kwargs["retries"] = self._pool.connection_pool_kw.get("retries")
        resp = self._pool.request(method, url, **kwargs)

        return resp
